﻿package nicocache.action
{
    import mx.controls.Alert;
    import mx.rpc.events.ResultEvent;
    import mx.rpc.events.FaultEvent;
    import mx.events.CloseEvent;
    
    import nicocache.Config;
    import nicocache.Constant;
    import nicocache.folder.FolderInfo;
    import nicocache.action.AbstractMultiAction;
    
    /**
     * 複数ファイル削除用クラス
     */
    public class MultiDeleteAction extends AbstractMultiAction
    {
        private var deleteAction:DeleteAction;
        
        /**
         * コンストラクタ
         * @param	items
         */
        public function MultiDeleteAction(items:Array) 
        {
            super(items);
            if (items.length == 0)
            {
                Alert.show("削除するファイルを選択してください。");
            }
        }
        
        /**
         * 削除を開始します。
         */
        override public function start():void
        {
            if (hasNext()) 
            {
                item = next();
                
                var conf:Config = Config.getInstance();
                var folderInfo:FolderInfo = FolderInfo.getInstance();
                
                deleteAction = new DeleteAction(item.id, folderInfo.path, item.tempfile, item.economy);
                deleteAction.type = Constant.ACTION_TYPE_MULTI;
                deleteAction.setDefaultHandler();
                
                // 確認する場合
                if (conf.confirmOption != Constant.CONFIRM_OPTION_NEVER)
                {
                    deleteAction.showConfirmDialog(function(closeEvent:CloseEvent):void {
                        // YESボタンが押されたら削除
                        if (closeEvent.detail == Alert.YES) execute(); // 削除実行
                        if (closeEvent.detail == Alert.NO) start(); // 再帰処理
                    });
                }
                // 確認しない場合
                else execute();
            } 
            else 
            {
                items = null;
                deleteAction = null;
            }
        }
        
        /**
         * 削除処理を実行します。
         */
        protected function execute():void
        {
            deleteAction.execute();
            start();
        }
    }
}