﻿package nicocache.action
{
    import mx.controls.Alert;
    import mx.rpc.events.ResultEvent;
    import mx.rpc.events.FaultEvent;
    
    import nicocache.Config;
    import nicocache.Constant;
    import nicocache.folder.FolderInfo;
    import nicocache.action.MoveAction;
    import nicocache.action.AbstractMultiAction;
    
    /**
     * 複数ファイル移動用クラス
     */
    public class MultiMoveAction extends AbstractMultiAction
    {
        private var targetFolder:String;
        private var moveAction:MoveAction;
        
        /**
         * コンストラクタ
         * @param	items
         */
        public function MultiMoveAction(items:Array) 
        {
            super(items);
            if (items.length == 0)
            {
                Alert.show("移動するファイルを選択してください。");
            }
        }
        
        /**
         * 移動を開始します。
         */
        override public function start():void
        {
            if (items.length > 0)
            {
                targetFolder = null;
                MoveAction.showFolderChooseDialog(function(ret:Object):void {
                    if (ret.result)
                    {
                        targetFolder = ret.path;
                        execute();
                    }
                });
            }
        }
        
        /**
         * 移動処理を実行します。
         */
        protected function execute():void
        {
            if (hasNext() && targetFolder != null)
            {
                item = next();
                
                var folderInfo:FolderInfo = FolderInfo.getInstance();
                
                moveAction = new MoveAction(item.id, folderInfo.path, targetFolder);
                moveAction.setDefaultHandler();
                moveAction.execute();
                
                execute();
            }
            else
            {
                items = null;
                moveAction = null;
            }
        }
    }
}