﻿package nicocache.controls
{
    import flash.geom.Point;
    import flash.geom.Rectangle;
    import mx.core.IToolTip;
    import mx.core.Application;
    import flash.events.MouseEvent;
    import mx.events.ToolTipEvent;
    import mx.controls.ToolTip;
    import mx.controls.dataGridClasses.DataGridItemRenderer;

    import nicocache.log.Logger;
    import nicocache.Constant;
    import nicocache.utils.StringTool;

    public class DefaultCacheItemRenderer extends DataGridItemRenderer
    {
        protected var app:Object;
        
        override public function initialize():void
        {
            super.initialize();
            styleName = "gridText";
            app = Application.application;
            addEventListener(MouseEvent.CLICK, clickEventHandler);
        }
        
        private function clickEventHandler(event:MouseEvent):void
        {
            var _data:Object = data;
            if (_data != null)
            {
                var id:String = String(_data[Constant.DATAFIELD_ID]);
                id = StringTool.altid2smid(id);
                app.setShowThumbInfo(id);
            }
        }

        override protected function toolTipShowHandler(event:ToolTipEvent):void
        {
            var toolTip:ToolTip = event.toolTip as ToolTip;
            toolTip.text = StringTool.replaceSpecialCharacter(toolTip.text);
            
            var pt:Point = new Point(0, 0);
            pt = localToGlobal(pt);
            pt = stage.globalToLocal(pt);			
            
            toolTip.move(pt.x + 10, pt.y + height + 5);
                
            var screen:Rectangle = systemManager.screen;
            var screenRight:Number = screen.x + screen.width;
            if (toolTip.x + toolTip.width > screenRight)
                toolTip.move(screenRight - toolTip.width, toolTip.y);
        }
    }
}
