﻿package nicocache.controls.column
{
    import mx.controls.dataGridClasses.DataGridColumn;
    import nicocache.Config;
    import nicocache.utils.StringTool;
    import mx.core.mx_internal;

    use namespace mx_internal;
    
    /**
     * カラム基底クラス
     *
     */
    public class CustomColumn extends DataGridColumn
    {
        protected var _columnId:String = null;
        protected var conf:Config = Config.getInstance();
        
        /**
         * コンストラクタ
         *
         */
        public function CustomColumn()
        {
            // カラムの移動が可能かどうか(Flex3)
            //draggable = false;
        }
        
        /**
         * IDプロパティ
         */
        public function get columnId():String
        {
            return _columnId;
        }
        
        /**
         * IDプロパティ
         * @param value 値
         */
        public function set columnId(value:String):void
        {
            _columnId = value;
        }

        /**
         * オブジェクトの大小比較を行います。
         *
         * @param a 比較対象オブジェクト1
         * @param b 比較対象オブジェクト2
         * @return 同じなら0、小さい場合は-1、大きい場合は1を返す
         */
        protected static function compareValues(a:Object, b:Object):int
        {
            if (a == null && b == null) return 0;
            if (a == null) return 1;
            if (b == null) return -1;
            if (a < b) return -1;
            if (a > b) return 1;
            return 0;
        }
        
        protected static function sanitizedLabelFunction(item:Object, column:DataGridColumn):String
        {
            var label:String = "";
            
            if (item != null)
            {
                label = String(item[column.dataField]);
                var findPos:int = label.indexOf("&");
                if (findPos >= 0)  label = StringTool.replaceSpecialCharacter(label, findPos);
            }
            
            return label;
        }
        
        /**
         * widthプロパティをオーバーライド
         */
        public override function get width():Number
        {
            var _width:Number = super.width;
            var _preferredWidth:Number = super.preferredWidth;
            
            if (columnId != null && _width != _preferredWidth)
            {
                conf.columns.data[columnId] = _width;
            }
            
            return _width;
        }
        
        /**
         * widthプロパティをオーバーライド
         * 
         * @param width 横幅
         */
        public override function set width(value:Number):void
        {
            super.width = value;
        }
        
        /**
         * サイズを設定
         * 
         * @param	value
         */
        public function setWidthInternal(value:Number):void
        {
            super.setWidth(value);  // internal
        }
    }
} 
