﻿package nicocache.controls.column
{
    import flash.net.SharedObject;
    import nicocache.Constant;
    import nicocache.controls.column.CustomColumn;
    import nicocache.controls.ImageButtonItemRenderer;
    import mx.core.ClassFactory;

    /**
     * IDカラム
     *
     */
    public class IdColumn extends CustomColumn
    {
        /**
         * コンストラクタ
         *
         */
        public function IdColumn()
        {
            super();
            // デフォルト値設定
            dataField           = Constant.DATAFIELD_ID;
            headerText          = "ID";
            width               = 155;
            resizable           = true;
            sortable            = true;
            itemRenderer        = new ClassFactory(ImageButtonItemRenderer);
            sortCompareFunction = idSortFunction;
        }

        /**
         * 動画IDの大小比較を行います。<br>
         *
         * @param obj1 比較対象オブジェクト1
         * @param obj2 比較対象オブジェクト2
         * @return 同じなら0、小さい場合は-1、大きい場合は1を返す
         */
        protected function idSortFunction(obj1:Object, obj2:Object):int
        {
            var id1:Number = Number(XMLList(obj1).@id.substring(2));
            var id2:Number = Number(XMLList(obj2).@id.substring(2));
            return compareValues(id1, id2);
        }
    }
}

