﻿package nicocache.log
{
    import mx.collections.ArrayCollection;
    import nicocache.log.LoggerHandler;

    /**
     * 簡易ロガークラス
     * 
     */
    public class Logger
    {
        /** レベル：DEBUG */
        public static const DEBUG:int = 1;
        /** レベル：INFORMATION */
        public static const INFO:int  = 2;
        /** レベル：WARNING */
        public static const WARN:int  = 3;
        /** レベル：ERROR */
        public static const ERROR:int = 4;
        /** レベル */
        public static var level:int   = INFO;
        public static var prefix:Array = new Array("", "DEBUG", "INFO", "WARN", "ERROR");

        /** ハンドラリスト */
        private static var handlers:ArrayCollection = new ArrayCollection();

        /**
         * ハンドラを追加します。
         * 
         * @param	handler ハンドラ
         */
        public static function addHandler(handler:LoggerHandler):void
        {
            handlers.addItem(handler);
        }

        /**
         * デバッグログを表示します。
         * 
         * @param	message メッセージ
         * @param	... args 可変引数
         */
        public static function debug(message:String, ... args):void
        {
            if (DEBUG < Logger.level) return;
            for each (var handler:LoggerHandler in handlers)
            {
                handler.debug(message, args);
            }
        }

        /**
         * 情報ログを表示します。
         * 
         * @param	message メッセージ
         * @param	... args 可変引数
         */
        public static function info(message:String, ... args):void
        {
            if (INFO < Logger.level) return;
            for each (var handler:LoggerHandler in handlers)
            {
                handler.info(message, args);
            }
        }

        /**
         * 警告ログを表示します。
         * 
         * @param	message メッセージ
         * @param	... args 可変引数
         */
        public static function warn(message:String, ... args):void
        {
            if (WARN < Logger.level) return;
            for each (var handler:LoggerHandler in handlers)
            {
                handler.warn(message, args);
            }
        }

        /**
         * エラーログを表示します。
         * 
         * @param	message メッセージ
         * @param	... args 可変引数
         */
        public static function error(message:String, ... args):void
        {
            if (ERROR < Logger.level) return;
            for each (var handler:LoggerHandler in handlers)
            {
                handler.error(message, args);
            }
        }
    }
}

