﻿package nicocache.utils 
{
    public class StringTool
    {
        /**
         * 特殊文字を置き換えます
         * 
         * @param	text 置き換え対象文字列
         * @param	startPos 開始位置
         * @return 置き換え後の文字列
         */
        public static function replaceSpecialCharacter(text:String, startPos:int = 0):String
        {
            var buf:Array = new Array();
            
            buf.push(text.substr(0, startPos));
            var i:int = startPos;
            while (i < text.length)
            {
                var c:String = text.charAt(i);
                switch(c)
                {
                case "&":
                    var str:String = text.substring(i + 1, i + 10);
                    // 基本的なものだけ置き換える
                    if (startsWith(str, "amp-"))  {
                        buf.push("&"); i += 5; continue;
                    } else if (startsWith(str, "lt-")) {
                        buf.push("<"); i += 4; continue;
                    } else if (startsWith(str, "gt-")) {
                        buf.push(">"); i += 4; continue;
                    } else if (startsWith(str, "quot-")) {
                        buf.push("\""); i += 6; continue;
                    } else if (startsWith(str, "nbsp-")) {
                        buf.push(" "); i += 6; continue;
                    } else if (startsWith(str, "copy-")) {
                        buf.push("©"); i += 6; continue;
                    }
                default:
                    buf.push(c);
                    i += 1;
                    break;
                }
            }
            
            return buf.join("");
        }
        
        /**
         * 開始文字が一致するか調べます。
         * 
         * @param	target 対象文字列
         * @param	str 比較文字列
         * @return 一致する場合true
         */
        public static function startsWith(target:String, str:String):Boolean
        {
            var ret:Boolean = true;
            
            if (target.length < str.length) return false;
            for (var i:int = 0; i < str.length; i++)
            {
                if (str.charAt(i) != target.charAt(i))
                {
                    ret = false;
                    break;
                }
            }
            
            return ret;
        }

        /**
         * altidから動画IDを取り出す
         *
         * @param	altid smXXXXXXXX(low)([720p,2000,192].mp4) の形式．
         *       	      括弧部分はないこともある．
         * @return smXXXXXXXX
         */
        public static function altid2smid(altid:String):String
        {
            var smid:String;
            var result:Object = /^(\w{2}\d+)/.exec(altid);
            if (result)
            {
                return result[1];
            }
            return "sm9"; // unreachable
        }
    }
}